/* *****************************************************************************
 * Copyright (c) IRISA Laboratory, 
 * Universite Bretagne Sud, France
 * <http://www-casa.irisa.fr/dodwan>
 *
 * This file is part of DoDWAN.
 * 
 * DoDWAN is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software 
 * Foundation, either version 3 of the License, or any later
 * version.
 * 
 * DoDWAN is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * DoDWAN.  If not, see <http://www.gnu.org/licenses/>.
 * ****************************************************************************/



package casa.dodwan.util;

public class Writer<E> implements Runnable {

	private Sink<E> sink_;

	private E value_ = null;

	// ------------------------------------------------------------
	public Writer(Sink<E> sink, E value) {
		sink_ = sink;
		value_ = value;
	}

	// ------------------------------------------------------------
	public void run() {

		try {
			sink_.write(value_);
		} catch (Exception e) {
			System.out.println("Writer.run(): could not write value " + value_
					+ " to sink " + sink_);
		}
	}

	// ------------------------------------------------------------
	public void setSink(Sink<E> sink) {
		sink_ = sink;
	}

	// ------------------------------------------------------------
	public void setValue(E value) {
		value_ = value;
	}

	// ------------------------------------------------------------
	public Sink<E> sink() {
		return sink_;
	}

	// ------------------------------------------------------------
	public E value() {
		return value_;
	}
}
